# setwd("C:/Users/Owner/Desktop/")

#library("rpart")
#data(iris)
#attach(iris)
f <- Species~Sepal.Length+Sepal.Width+Petal.Length+Petal.Width
fit <- rpart(f,data=iris)
# print(fit)
#plot(fit)
#text(fit)
# lots if info on fit is available at ?rpart.object
# it seems that fit$frame$complexity is how to make
# the tree leafier (or not)... but how?
# let's look at rpart.control...
# YES! this seems to have all of the parameters!
# params:
# minsplit = 20 ~ min. # of obs to try a split
# minbucket = 6 ~ min. # obs in any leaf node
# cp = 0.01 ~ complexity parameter
# xval = 10 ~ number of cross-validations used (!?)
# is this global?
# just calling it seems NOT to work...
#rpart.control( minsplit=125 )
# try with the parameters embedded:
fit2 <- rpart(f,data=iris,minsplit=125)
#plot(fit2)
#text(fit2)
# that did it! now the tree has only one split...
fit3 <- rpart(f,data=iris,minbucket=1,cp=0.0)
plot(fit3)
# let's see the overfitting!
# predict(fit3,newdata=iris) 
# gives a pretty crazy structure...
p<-predict(fit3,newdata=iris)
# p
#     setosa versicolor virginica
# 1        1          0         0
# 2        1          0         0
# 3        1          0         0
# we want the labels themselves...
# wow - we need dimnames(p) to get names
# [[2]] yields the column names
add1 <- function(x)
{
  return(x+1)
}
# no fiddling with mapply, vapply, et al. seems to work...
# so, we write our own!
# we could - but!!!
# I looked up predict.rpart (ok, so that's how the naming is done...)
# and it seems you can run
pred_res <- predict(fit3,data=iris,type="class")
# ok, now our table
print(table(Species,pred_res))

# now I just need the prp package to test it out!
# in the meantime, let's take a look at pruning
# the rpart trees...
# prune.rplot looks good - it prunes to a complexity parameter

# rsq.rpart(fit) plots something...
# plotcp seems to be a good function for determining
# the "correct" size of the tree...

# xpred.rpart <- cross-validation
# not sure about that, but now we have rpart.plot
# and its accompanying function prp
library("rpart.plot")
# run ?prp and ?rpart.plot
